#!/usr/bin/perl

use strict;
use warnings;
use Getopt::Std;

my %opts;
getopts('f:s:h', \%opts);

if ( $opts{h} ) { die "usage: $0 -f <input file> -s <location of smbpasswd(8)>\n"; }

my $file = "useraccounts";
if ( $opts{f} ) { $file = $opts{f}; }

my $smbpasswd = "/usr/local/bin/smbpasswd";
if ( $opts{s} ) { $smbpasswd = $opts{s}; }

open LIST,$file; 

while ( my $line = <LIST> )
	{
	$line =~ m/Username:\s(\w+)\spassword:\s(.*?)\s/;
	my $username = $1;
	my $password = $2;
	open SMBPIPE,"| $smbpasswd -s -a $username";
	print SMBPIPE "$password\n$password\n"; 
	close SMBPIPE;
	}

close LIST;
